/////////////////////////////////////////////////////////////////////////////////
//
// PGPlog.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//


/////////////////////////////////////////////////////////////////////////////////
//
#include "PGPlog.h"


/////////////////////////////////////////////////////////////////////////////////
//
PGPlog* PGPlog::instance = NULL;
CriticalSection PGPlog::critsec;
long PGPlog::counter = 0;


/////////////////////////////////////////////////////////////////////////////////
//
PGPlog::PGPlog()
{
    bool result = false;
    do {
        pgpsc_instance = LoadLibrary("PGPSC.DLL");
        if (pgpsc_instance < reinterpret_cast<HINSTANCE>(HINSTANCE_ERROR)) {
            pgpsc_instance = NULL;
            return;
        }
        if (!((FARPROC&)SendPGPlogMsg = GetProcAddress(pgpsc_instance, "SendPGPlogMsg"))) break;
        result = true;
    } while (false);

    if (!result) {
        pgpsc_instance = NULL;
    }
}


PGPlog::~PGPlog()
{
    if (pgpsc_instance) {
        FreeLibrary(pgpsc_instance);
    }
    instance = NULL;
}


PGPlog* PGPlog::Instance()
{
    critsec.enter();

    InterlockedIncrement(&counter);
    if (instance == NULL) {
        instance = new PGPlog();
    }

    if (instance->pgpsc_instance == NULL) {
        delete instance;
        instance = NULL;
    }

    critsec.leave();

    return instance;
}


void PGPlog::Release()
{
    critsec.enter();

    if (InterlockedDecrement(&counter) == 0) {
        delete instance;
    }

    critsec.leave();
}


bool PGPlog::setLogMessage(HWND hwnd, char *mes)
{
    if (!pgpsc_instance) {
        return false;
    }
    return (SendPGPlogMsg(hwnd, mes) == TRUE);
}


/////////////////////////////////////////////////////////////////////////////////
//
