////////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2Decode.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2Decode.cpp,v $
 * Revision 1.7  2000/11/29 12:46:35  syou
 * - broken version line ̏CBsɂ܂Ă͖̂炩Ƀ~X
 *   łB
 *
 * Revision 1.6  2000/11/23 07:17:58  syou
 * - DllMainŎqXbh쐬Ă߁APGPB2[hĂȂԂŁA
 *   B2̃vOC̑I_CAOJƂAB2ƂɗĂ
 *   oOCBWindows98ŏ؂̃bZ[WpƂȂĂ̂C
 *   BlXg`ɂȂĂPGP/MIME[̕ƌ؂肭oȂ
 *   oOPgpb2::decodePgpMailPartPgpb2::decodePgpMailPart2ŏCB
 *   Decode܂̃WbŇccłB
 *   PGP/MIMEbZ[W̕ƌ؋@\ǉB،ʂɂẮAƂ肠
 *   PGPlogɕ\悤ɂ݂܂Bo̓bZ[W\[X֒ǕB
 *
 * Revision 1.5  2000/11/08 16:50:47  syou
 * - PGPlogɃbZ[Wo͂邽߂ɁAclass PGPlogVK쐬B
 *   FXKvɂȂ肻Ȃ̂ŁAclass CriticalSectionVK쐬B
 *
 * Revision 1.4  2000/11/07 15:57:19  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 */


#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


////////////////////////////////////////////////////////////////////////
//
#include "Pgpb2.h"
#include "PGPlog.h"
#include <pgpFeatures.h>

////////////////////////////////////////////////////////////////////////
// Decode
/**
 * PGP MIME decode
 */
bool Pgpb2::decodePgpMime(HWND hWnd, PgpMail* mail)
{
    // Config擾
    config = b2apiex->GetConfig();

    // ،ʂ
    correct.init();

    // multipartAsignedtypemime part
    return decodePgpMailPart(mail, hWnd);
}


/**
 * PGP NOT MIME decode
 */
bool Pgpb2::decodeNotPgpMime(HWND hWnd, PgpMail* mail)
{
    // Config擾
    config = b2apiex->GetConfig();

    // ،ʂ
    correct.init();

    bool result = false;
    string text = mail->getText();
    string::size_type pos_next = 0;

    do {
        string::size_type pos_begin = text.find("-----BEGIN PGP ", pos_next, 15);
        if (pos_begin == string::npos) {
            pos_begin = text.find("\n-----BEGIN PGP ", pos_next, 16);
            if (pos_begin == string::npos) {
                break;
            }
        }

        bool isDecrypt = true;
        bool isSign = false;
        if (text.compare(pos_begin, 36, "-----BEGIN PGP PUBLIC KEY BLOCK-----") == 0) {
            return result;//isDecrypt = false;
        }
        else if (text.compare(pos_begin, 34, "-----BEGIN PGP SIGNED MESSAGE-----") == 0) {
            isDecrypt = false;
            isSign = true;
        }

        string::size_type pos_end = text.find("\n-----END PGP ", pos_begin);
        if (pos_end == string::npos) {
            break;
        }

        string pgp = text.substr(pos_begin, pos_end - pos_begin + 1);
        string out;
        DecryptListener decListener(hWnd, cache);
        if (isDecrypt && !isSign) {
            if (decrypt(pgp, decListener, out)) {
                if (result) {
                    text += out;
                }
                else {
                    text = out;
                    result = true;
                }
                text += "\r\n";
            }
        }
        else if (!isDecrypt && isSign) {
            verifyAttachedSignature(pgp, decListener);
        }

        if (decListener.isSigned()) {
            char charset[80];
            string subject = mail->getHeader("Subject");
            LPSTR temp = b2api->MIMEHeader(subject.c_str(), charset, 80, FALSE);
            subject.assign(temp);
            b2api->Free(temp);
            SigEvent(hWnd, decListener, subject);
        }

        pos_next = pos_end + 1;
    } while (true);

    if (result && !text.empty()) {
        text += "***************** Original PGP message follows *****************\r\n\r\n";
        mail->setText(text);
    }

    return result;
}
//*/

////////////////////////////////////////////////////////////////////////
// find PGP MIME
bool Pgpb2::decodePgpMailPart(BkMail* targetMailPart, HWND hWnd)
{
    bool decode = false;
    decode = decodePgpMailPart2(targetMailPart, hWnd);

    BkMailList::iterator first = targetMailPart->findMimeItem("message", "rfc822", FINDMIMEITEM_DEFAULT);
    BkMailList::iterator end = targetMailPart->end();
    for (; first != end; ++first) {
        BkMail* parent = *first;
        BkMail* rfc822;
        rfc822 = parent->getRfc822();
        if (rfc822) {
            if (decodePgpMailPart(rfc822, hWnd)) {
                string source = rfc822->toString();
                parent->clearBody();
                parent->pushBodyBack(source);
                decode = true;
            }
            delete rfc822;
        }
    }
    return decode;
}


bool Pgpb2::decodePgpMailPart2(BkMail* targetMailPart, HWND hWnd)
{
    bool decode = false;
    BkMailList::iterator first = targetMailPart->findMimeItem("multipart", "encrypted", FINDMIMEITEM_DEFAULT);
    BkMailList::iterator end = targetMailPart->end();
    while (first != end) {
        if (decryptPgpMimeMail(*first, hWnd)) {
            first = targetMailPart->findMimeItem("multipart", "encrypted", FINDMIMEITEM_DEFAULT);
            end = targetMailPart->end();
            decode |= true;
        }
        else {
            ++first;
        }
    }
    first = targetMailPart->findMimeItem("multipart", "signed", FINDMIMEITEM_DEFAULT);
    for (; first != end; ++first) {
        decode |= verifyPgpMimeMail(*first, hWnd);
    }

    return decode;
}


////////////////////////////////////////////////////////////////////////
// PGP
bool Pgpb2::verifyPgpMimeMail(BkMail* targetMailPart, HWND hWnd)
{
    // MIMEACeAPGP/MIMEp[gT
    //
    // PGP/MIME͉̎L̂悤ȃC[W
    // mail: ep[g
    //    child1: {iꂽbZ[WjFmailgetChild()Ŏ擾
    //    child2: child1getNext()Ŏ擾
    BkMail* child1;
    child1 = targetMailPart->getChild();
    if (child1 == NULL || child1->isMime("application", "pgp-signature")) {
        return false;
    }

    BkMail* child2;
    child2 = child1->getNext();
    if (child2 == NULL || !child2->isMime("application", "pgp-signature")) {
        return false;
    }

    // PGP/MIMEp[g̃\[X擾
    string pgp = child2->toString();

    // ۂɏ݂邩A擪"-----BEGIN PGP SIGNATURE-----"݂̑mF
    string::size_type pos = pgp.find("-----BEGIN PGP SIGNATURE-----");
    if (pos == string::npos) {
        return false;
    }

    // ̃\[X擾
    string sign = pgp.substr(pos);

    // {̃\[X擾
    string body;
    body = child1->toString();
    if (body.empty()) {
        return false;
    }

    // ؂̎s
    SignatureListener sigListener;
    if (!verifyDetachedSignature(body, sign, sigListener)) {
        return false;
    }

    // ،ʂ̉
    if (sigListener.isSigned()) {
        string out;
        if (explainSigningMessage(sigListener, out)) {
            BkMail* child3;
            string ctype = "multipart/mixed; boundary=\"" + targetMailPart->getBoundary() + "\"";
            targetMailPart->setHeader("Content-Type", ctype);
            targetMailPart->setHeader("Content-Transfer-Encoding", "8bit");
            child3 = child1->setNext(new BkMail());
            child3->setHeader("Content-Type", "text/plain; charset=\"UTF-8\"");
            child3->setHeader("Content-Transfer-Encoding", "8bit");
            child3->pushBodyBack(out);
        }
    }

    return true;
}


////////////////////////////////////////////////////////////////////////
// PGP
bool Pgpb2::decryptPgpMimeMail(BkMail* targetMailPart, HWND hWnd)
{
    BkMail* child1;
    child1 = targetMailPart->getChild();
    if (child1 == NULL || !child1->isMime("application", "pgp-encrypted")) {
        return false;
    }

    BkMail* child2;
    child2 = child1->getNext();
    if (child2 == NULL || !child2->isMime("application", "octet-stream")) {
        return false;
    }

    // PGP/MIMËÍ̃\[X擾
    string encrypt = child2->toString();
    if (encrypt.empty()) {
        return false;
    }

    // Í̃\[X
    string::size_type pos = encrypt.find("-----BEGIN PGP ");
    if (pos == string::npos) {
        return false;
    }

    string pgp = encrypt.substr(pos);

    string out;
    DecryptListener decListener(hWnd, cache);
    if (!decrypt(pgp, decListener, out)) {
        return false;
    }

    string ctype = "multipart/mixed; boundary=\"" + targetMailPart->getBoundary() + "\"";
    targetMailPart->setHeader("Content-Type", ctype);
    targetMailPart->setChild(new BkMail(out));

    /* Test validity of signature here */
    if (decListener.isSigned()) {
        if (explainSigningMessage(decListener, out)) {
            BkMail* child2;
            child2 = targetMailPart->addChild(new BkMail());
            child2->setHeader("Content-Type", "text/plain; charset=\"UTF-8\"");
            child2->setHeader("Content-Transfer-Encoding", "8bit");
            child2->pushBodyBack(out);
        }
    }

    return true;
}


////////////////////////////////////////////////////////////////////////
//
/**
 * Detachedȏ̌
 */
bool Pgpb2::verifyDetachedSignature(const string& body, const string& sign, SignatureListener& sigListener)
{
    bool result = false;
    PGPError err = kPGPError_NoErr;
    PGPKeySetRef defaultKeyRing = kInvalidPGPKeySetRef;

    try {
        // Default Key RingJ
        err = PGPOpenDefaultKeyRings(context, FALSE, &defaultKeyRing);
        PGPCheckSdkError(err, "The error occured in OpenDefaultKeyRings.");

        err = PGPDecode(context,
                PGPOKeySetRef(context, defaultKeyRing),
                PGPOSetEventHandler(context, &sigListener),
                PGPOInputBuffer(context, sign.c_str(), sign.size()),
                PGPODetachedSig(context,
                    PGPOInputBuffer(context, body.c_str(), body.size()),
                    PGPOLastOption(context)),
                PGPOLastOption(context) );

        PGPCheckSdkError(err, "The error occured in Decode.");
        result = true;

    } catch (PGPSdkError& sdkError) {
        std::string message = sdkError.getErrorSpecification();
        ::MessageBox(b2apiex->GetMainWindowHandle(), message.c_str(), "PGPB2 - Error", MB_OK | MB_ICONERROR);
    }

    if (PGPKeySetRefIsValid(defaultKeyRing)) {
        PGPFreeKeySet(defaultKeyRing);
    }

    return result;
}


/**
 * Attachedȏ̌
 */
bool Pgpb2::verifyAttachedSignature(const string& pgp, SignatureListener& sigListener)
{
    bool result = false;
    PGPError err = kPGPError_NoErr;
    PGPKeySetRef defaultKeyRing = kInvalidPGPKeySetRef;

    try {
        // Default Key RingJ
        err = PGPOpenDefaultKeyRings(context, FALSE, &defaultKeyRing);
        PGPCheckSdkError(err, "The error occured in OpenDefaultKeyRings.");

        err = PGPDecode(context,
                PGPOKeySetRef(context, defaultKeyRing),
                PGPOSetEventHandler(context, &sigListener),
                PGPOInputBuffer(context, pgp.c_str(), pgp.size()),
                PGPODiscardOutput(context, TRUE),
                PGPOLastOption(context) );

        PGPCheckSdkError(err, "The error occured in Decode.");
        result = true;

    } catch (PGPSdkError& sdkError) {
        std::string message = sdkError.getErrorSpecification();
        ::MessageBox(b2apiex->GetMainWindowHandle(), message.c_str(), "PGPB2 - Error", MB_OK | MB_ICONERROR);
    }

    if (PGPKeySetRefIsValid(defaultKeyRing)) {
        PGPFreeKeySet(defaultKeyRing);
    }

    return result;
}


/**
 * 
 */
bool Pgpb2::decrypt(const string& pgp, DecryptListener& decListener, string& out)
{
    bool result = false;
    PGPError err = kPGPError_NoErr;
    PGPKeySetRef defaultKeyRing = kInvalidPGPKeySetRef;
    LPSTR lpArea = NULL;

    try {
        // Default Key RingJ
        err = PGPOpenDefaultKeyRings(context, FALSE, &defaultKeyRing);
        PGPCheckSdkError(err, "The error occured in OpenDefaultKeyRings.");

        PGPSize outputSize = 0;

        err = PGPDecode(context,
                PGPOInputBuffer(context, pgp.c_str(), pgp.size()),
                PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &outputSize),
                PGPOKeySetRef(context, defaultKeyRing),
                PGPOSetEventHandler(context, &decListener),
                PGPOLastOption(context)
                );

        PGPCheckUserAbort(err, "User Canceled.");
        if (IsPGPError(err) || lpArea == NULL) {
            throw PGPSdkError(err, "The error occured in Decode.");
        }

        out.assign(lpArea);
        result = true;

    } catch (PGPSdkError& sdkError) {
        std::string message = sdkError.getErrorSpecification();
        ::MessageBox(b2apiex->GetMainWindowHandle(), message.c_str(), "PGPB2 - Error", MB_OK | MB_ICONERROR);
    } catch (PGPUserError& userError) {
        b2api->SetMessageText(NULL, userError.what());
    }

    if (lpArea) {
        PGPFreeData(lpArea);
    }
    if (PGPKeySetRefIsValid(defaultKeyRing)) {
        PGPFreeKeySet(defaultKeyRing);
    }

    return result;
}


////////////////////////////////////////////////////////////////////////
// ̐}
bool Pgpb2::explainSigningMessage(const SignatureListener& sigListener, string& out)
{
    /* Test validity of signature here */
    if (!sigListener.isSigned()) {
        return false;
    }

    char szBuf[32768];

    // PGPB2̃bZ[W
    string result;
    result += mes->getsfr(IDS_VERIFY); //"̃[PGP/MIMEĂ܂B"
    result += "\r\n\r\n";

    if (sigListener.isChecked()) {

        /* There was a signature in the file */
        sprintf(szBuf, mes->getsfr(IDS_VERIFY_WHOSIGN).c_str(), sigListener.getName().c_str()); //": %s\r\n"
        result += szBuf;

        if (sigListener.isVerified()) {
            /* The signature verified */
            result += mes->getsfr(IDS_VERIFY_GOODSIG); // "łB\r\n"
            result += "\r\n";
        } else {
            result += mes->getsfr(IDS_VERIFY_BADSIG); //"sȏłB\r\n{̓eƏv܂B\r\n"
            result += "\r\n";
        }

        char szBufGmt[1024];
        char szBufLmt[1024];
        time_t creationTime;
        creationTime = PGPGetStdTimeFromPGPTime(sigListener.getData()->creationTime);
        strftime(szBufGmt, 1024, mes->getsfr(IDS_VERIFY_SIGNTIME_GMT).c_str(),   gmtime(&creationTime)); //"%Y/%m/%d %H:%M:%S GMT"
        strftime(szBufLmt, 1024, mes->getsfr(IDS_VERIFY_SIGNTIME_LOCAL).c_str(), localtime(&creationTime)); //"%Y/%m/%d %H:%M:%S %Z"
        sprintf(szBuf, mes->getsfr(IDS_VERIFY_SIGNTIME).c_str(), szBufGmt, szBufLmt); //" %s (%s) ɍ쐬܂B"
        result += szBuf;
        result += "\r\n";

        char keyidstr[19];
        SEGetKeyIDString(sigListener.getData()->signingKeyID, keyidstr,sizeof(keyidstr));
        sprintf(szBuf, mes->getsfr(IDS_VERIFY_KEYID).c_str(), keyidstr);
        result += szBuf;

    }


    if (sigListener.getKeyValidity() == kPGPValidity_Unknown) {
        sprintf(szBuf, mes->getsfr(IDS_VERIFY_UNKNOWNKEYID).c_str(), sigListener.getName());
        result += szBuf;
        result += mes->getsfr(IDS_VERIFY_UNKNOWNKEY); //"̏؂邽߂̌J܂B\r\n"
        result += "\r\n";
    }
    else {
        // Validity (L) Check
        result += mes->getsfr(IDS_VERIFY_VALIDITY);

        switch (sigListener.getKeyValidity()) {
        case kPGPValidity_Unknown:
        case kPGPValidity_Marginal:
        case kPGPValidity_Invalid:
            {
                switch (sigListener.getKeyValidity()) {
                case kPGPValidity_Marginal:
                    result += mes->getsfr(IDS_VERIFY_VALIDITY_MARGINALLY); //"x: ͍̌ŒL(Marginally)łB\r\n"
                    break;
                case kPGPValidity_Invalid:
                    result += mes->getsfr(IDS_VERIFY_VALIDITY_INVALID); //"xF͖̌łB"
                    break;
                default:
                    break;
                }
                result += mes->getsfr(IDS_VERIFY_VALIDITY_BAD); //"xF̌́AMꂽŏؖĂ܂B\r\n"
            }
            break;
        case kPGPValidity_Complete:
            if (sigListener.isAxiomatic()) {
                result += mes->getsfr(IDS_VERIFY_VALIDITY_AXIOMATIC);
            } else {
                result += mes->getsfr(IDS_VERIFY_VALIDITY_COMPLETE);
            }
        default:
            break;
        }

        // Trust (Mpx) Check
        result += mes->getsfr(IDS_VERIFY_TRUST);

        switch (sigListener.getTrustValue()) {
        case kPGPKeyTrust_Never:
            result += mes->getsfr(IDS_VERIFY_TRUST_NEVER);
            break;
        case kPGPKeyTrust_Marginal:
            result += mes->getsfr(IDS_VERIFY_TRUST_MARGINAL);
            break;
        case kPGPKeyTrust_Complete:
            result += mes->getsfr(IDS_VERIFY_TRUST_COMPLETE);
            break;
        case kPGPKeyTrust_Ultimate:
            result += mes->getsfr(IDS_VERIFY_TRUST_ULTIMATE);
            break;
        default:
            break;
        }

        // State () Check
        bool keyState = true;
        result += mes->getsfr(IDS_VERIFY_STATE);
        if (sigListener.getData()->keyRevoked) { // ꂽAp~ꂽAɂꂽ
            result += mes->getsfr(IDS_VERIFY_STATE_REVOKED);//"Signing key is revoked.\r\n";
            keyState = false;
        }
        if (sigListener.getData()->keyDisabled) { // ɗȂꂽA͂ɂꂽAȂꂽ
            result += mes->getsfr(IDS_VERIFY_STATE_DISABLED);//"Signing key is disabled.\r\n";
            keyState = false;
        }
        if (sigListener.getData()->keyExpired) { // ȂǂA_񂪐؂ꂽ
            result += mes->getsfr(IDS_VERIFY_STATE_EXPIRED);//"Signing key is expired.\r\n";
            keyState = false;
        }
        if (!sigListener.getData()->keyMeetsValidityThreshold) { // !LȔ͈͂ɖ
            result += mes->getsfr(IDS_VERIFY_STATE_THRESHOLD);//"Key does not meet validity threshold.\r\n";
            keyState = false;
        }
        if (keyState) {
            result += mes->getsfr(IDS_VERIFY_STATE_GOOD);
        }

    }

    result += mes->getsfr(IDS_VERIFY_PGPB2SIG); //-- \nPGPB2 version x.xx.x\r\nhttp://www.ops.dti.ne.jp/~yuga/koubou/\r\n
    out = toUtf8(result);

    // ،
    correct.setCorrect(sigListener.isChecked() && sigListener.isVerified());

    if (config.isDisplayVerificationResultOnListView()) {
        if (correct.getCorrect()) {
            SetCorrect();
        } else {
            SetInCorrect();
        }
    }

    return true;
}


void Pgpb2::SigEvent(HWND hwnd, SignatureListener& sigListener, const string& subject)
{
    DWORD Validity;
    PGPBoolean bAxiomatic,bKeyCanSign;
    char szMsgStr[500];
    //BOOL bMarginalInvalid;
    const PGPEventSignatureData *d;

    bAxiomatic=FALSE;
    bKeyCanSign=TRUE;
    d = sigListener.getData();

    // Icon information for PGPlog

    if(d->verified) {
        strcpy(szMsgStr,"Good Signature\n");
    } else {
        strcpy(szMsgStr,"Bad Signature\n");
    }

    // Filename (or Clipboard... or Eudora.. etc)
    sprintf(&(szMsgStr[strlen(szMsgStr)]),"%s\n", subject.c_str());

    // Get name and raw Validity number
    if((d->signingKey)==0) {
        char keyidstr[11];

        strcat(szMsgStr,"(Unknown, KeyID=");
        strcat(szMsgStr,sigListener.getName().c_str());
        strcat(szMsgStr,")\n");

        Validity=kPGPValidity_Unknown ;
    } else {
        sprintf(&(szMsgStr[strlen(szMsgStr)]),"%s\n",sigListener.getName().c_str());
        Validity = sigListener.getKeyValidity();
        bAxiomatic = sigListener.isAxiomatic();
        bKeyCanSign = sigListener.isSigningKey();
    }

    if (pgpversion.find("ckt") != std::string::npos) {
        char mykeyidstr[19];
        SEGetKeyIDString(d->signingKeyID,mykeyidstr,sizeof(mykeyidstr));
        strcat(szMsgStr,mykeyidstr);
        strcat(szMsgStr,"\n");
    }

    // Decode validity into string
    if(bAxiomatic) {

        strcat(szMsgStr,"Implicit Trust\n"); // Axiomatic

    } else switch(Validity) {
        case kPGPValidity_Marginal :
            strcat(szMsgStr,"Marginal Key\n");
            break;
        case kPGPValidity_Complete :
            strcat(szMsgStr,"Valid Key\n");
            break;
        default :
            strcat(szMsgStr,"Invalid Key\n");
            break;
    }

    // Output date and/or extra info
    if(!bKeyCanSign) {
        strcat(szMsgStr,"Signing algorithm not supported");
    }
    else if ((d->verified==0)&&(d->signingKey!=0)) {
        strcat(szMsgStr,"Bad Signature\n");
    }
    else {

        //GetMarginalInvalidPref(context,&bMarginalInvalid);
        ConvertSigTimeToString(d->creationTime,
                                &(szMsgStr[strlen(szMsgStr)]),
                                500-strlen(szMsgStr));

        if(d->signingKey==0) {
            strcat(szMsgStr," (Unknown Key)");
        } else if (d->keyRevoked) {
            strcat(szMsgStr," (Revoked Key)");
        } else if (d->keyExpired) {
            strcat(szMsgStr," (Expired Key)");
        } else if (d->keyDisabled) {
            strcat(szMsgStr," (Disabled Key)");
        } else if (Validity==kPGPValidity_Unknown || Validity==kPGPValidity_Invalid) {
            strcat(szMsgStr," (Invalid Key)");
        } else if(/*(bMarginalInvalid)&&*/(Validity==kPGPValidity_Marginal)) {
            strcat(szMsgStr," (Invalid Key)");
        }
    }

    // Send DDEML msg to PGPlog
    if (config.isUsePGPlog()) {
        PGPlog* log = PGPlog::Instance();
        log->setLogMessage(hwnd, szMsgStr);
        log->Release();
    }

    // ،
    correct.setCorrect(d->verified != 0);

    // Display verification result on ListView
    if (config.isDisplayVerificationResultOnListView()) {
        if (correct.getCorrect()) {
            SetCorrect();
        } else {
            SetInCorrect();
        }
    }

}


////////////////////////////////////////////////////////////////////////
//
#pragma warning(pop) /* restore previous warning */
