////////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2Encode.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//


#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


////////////////////////////////////////////////////////////////////////
//
#include "Pgpb2.h"
#include "stringfr.h"


////////////////////////////////////////////////////////////////////////
// PGPÍ
bool Pgpb2::encrypt(HWND hWnd, PgpMail* mail)
{
    // 
    bool result = false;

    // Config擾B
    config = b2apiex->GetConfig();

    // "To"A"Cc"A"Bcc"̊ewb_ mailaddress 𒊏oA|C^XgɊi[B
    string to;
    string cc;
    string bcc;

    // Resent[̏ꍇResentwb_AȊO͒ʏ̃wb_
    if (mail->getHeader("Resent-Message-Id").length()) {
        to = mail->getHeader("Resent-To");
        cc = mail->getHeader("Resent-Cc");
        bcc = mail->getHeader("Resent-Bcc");
    } else {
        to = mail->getHeader("To");
        cc = mail->getHeader("Cc");
        bcc = mail->getHeader("Bcc");
    }

    // Bcc̋Lq
    if (config.isWarningBccExist() && !bcc.empty()) {
        int res = ::MessageBox(hWnd, mes->getsfr(IDS_WARNING_BCCEXIST).c_str(),
            "PGPB2 - Warning", MB_YESNOCANCEL | MB_ICONWARNING | MB_DEFBUTTON2);
        if (res == IDNO) {
            bcc.erase();
        } else if (res ==IDCANCEL) {
            return false;
        }
    }

    CPointerList lstAddr;
    addAddressList(lstAddr, to);
    addAddressList(lstAddr, cc);
    addAddressList(lstAddr, bcc);

    // i[ mailaddress Ƃ return B
    CPointerItem* pItem = lstAddr.GetTop();
    if (pItem == NULL) {
        return result;
    }

    // Clean upKvȕϐ`
    PGPKeySetRef defaultKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef foundUserKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef encryptKeySet = kInvalidPGPKeySetRef;
    PGPOptionListRef encodeOptionList = kInvalidPGPOptionListRef;
    LPSTR lpArea = NULL;

    try {
        // Default Key RingJB
        PGPError err = PGPOpenDefaultKeyRings(context, FALSE, &defaultKeySet);
        PGPCheckSdkError(err, "The error occured in PGPOpenDefaultKeyRings.");

        // e mailaddress ɑΉL[܂Ƃ߂ĒoB
        getKeySet(pItem, defaultKeySet, foundUserKeySet);

        // Default Recipients擾B
        std::vector<PGPRecipientSpec> spec;
        int numberOfDefault = getDefaultRecipients(foundUserKeySet, spec);
        if (numberOfDefault == 0) {
            throw PGPUserError("Not found any key of recipients in Default Key Ring");
        }

        // ÍɎgp錮iljI_CAO\B
        // CheckBoxł"Conventional &Encryption"̖O͌ŒB
        // cktłł݂͂āAListBoxEnableADisablesĂB
        PGPUInt32 initialValueOfPgpMime = (pgpmime) ? TRUE : FALSE;
        PGPUInt32 resultValueOfPgpMime;
        PGPUInt32 initialValueOfConv = FALSE;
        PGPUInt32 resultValueOfConv;

        err = PGPRecipientDialog(
                context,
                defaultKeySet,
                TRUE,
                &encryptKeySet,
                PGPOUIParentWindowHandle(context, hWnd),
                PGPOUIDialogOptions(context,
                    PGPOUICheckbox(context, 1, "&PGP/MIME_RFC2015", NULL,
                        initialValueOfPgpMime, &resultValueOfPgpMime,
                        PGPOLastOption(context)),
                    PGPOUICheckbox(context, 2, "Conventional &Encryption", NULL,
                        initialValueOfConv, &resultValueOfConv,
                        PGPOLastOption(context)), 
                    PGPOLastOption(context)),
                //PGPOUIDisplayMarginalValidity(context, TRUE),
                PGPOUIDefaultRecipients(context, numberOfDefault, &spec[0]),
                PGPOLastOption(context)
                );

        PGPCheckUserAbort(err, "User Canceled.");
        PGPCheckSdkError(err, "The error occured in PGPRecipientDialog.");

        // OptionList̍\z
        err = PGPBuildOptionList(
                context,
                &encodeOptionList,
                PGPOVersionString(context, mes->getsfr(IDS_PGPB2_VERSION).c_str()),
                PGPOArmorOutput(context, TRUE),
                PGPOLastOption(context)
                );

        PGPCheckSdkError(err, "The error occured in PGPBuildOptionList.");
       
        // Conventional EncryptionsH
        if (resultValueOfConv == TRUE) {
            appendConventionalEncryptionOptionList(hWnd, encodeOptionList);
        } else {
            appendEncryptionOptionList(encryptKeySet, encodeOptionList);
        }

        // Í镽擾B
        pgpmime = (resultValueOfPgpMime == TRUE);
        string text = mail->getPgpOriginalText(hWnd, pgpmime);
        if (text.size() == 0) {
            throw PGPUserError("User's mail don't have text");
        }

        /*// Debug code
        FILE* fp;
        fp = fopen("E:\\syou\\mail1.txt", "wb");
        fwrite(text.c_str(), text.size(), 1, fp);
        fclose(fp);
        //*/

        // PGPɂencodesB
        PGPSize size;
        err = PGPEncode(
                context,
                encodeOptionList,
                PGPOInputBuffer(context, text.c_str(), text.size()),
                PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &size),
                PGPOLastOption(context)
                );

        if (IsPGPError(err) || lpArea == NULL) {
            throw PGPSdkError(err, "The error occured in PGPEncode.");
        }

        // [̕ҏWB
        if (pgpmime) {
            char szBoundary[1024];  // MIMEboundary ؂蕶
            char szData[8192];
            time_t t;
            time(&t);   // ݂̎擾 boundaryɖߍ
            sprintf(szBoundary, "===[PGP/MIME_RFC2015]===%08X.%04X===", (DWORD)t, &t);
            sprintf(szData, "multipart/encrypted;\r\n boundary=\"%s\";\r\n protocol=\"application/pgp-encrypted\"", szBoundary);
            mail->setHeader("Content-Type", szData);
            mail->setHeader("Content-Transfer-Encoding", "7bit");
            mail->clearBody();

            BkMail* child1 = mail->setChild(new BkMail());
            child1->setHeader("Content-Type", "application/pgp-encrypted");
            child1->setHeader("Content-Transfer-Encoding", "7bit");
            child1->pushBodyBack("Version: 1\r\n");

            BkMail* child2 = mail->addChild(new BkMail());
            child2->setHeader("Content-Type", "application/octet-stream");
            child2->setHeader("Content-Transfer-Encoding", "7bit");
            child2->pushBodyBack(lpArea);
        }
        else {
            mail->setText(lpArea);
        }

        result = true;

    } catch (PGPSdkError& sdkError) {
        std::string message = sdkError.getErrorSpecification();
        ::MessageBox(hWnd, message.c_str(), "PGPB2 - Error", MB_OK | MB_ICONERROR);
    } catch (PGPUserError& userError) {
        b2api->SetMessageText(hWnd, userError.what());
    }

    // Clean up
    if (PGPOptionListRefIsValid(encodeOptionList)) {
        PGPFreeOptionList(encodeOptionList);
    }
    if (PGPKeySetRefIsValid(encryptKeySet)){
        PGPFreeKeySet(encryptKeySet);
    }
    if (PGPKeySetRefIsValid(defaultKeySet)) {
        PGPFreeKeySet(defaultKeySet);
    }
    if (lpArea) {
        PGPFreeData(lpArea);
    }

    return result;
}


////////////////////////////////////////////////////////////////////////
// PGP
bool Pgpb2::signing(HWND hWnd, PgpMail* mail)
{
    // 
    bool result = false;

    // Config擾
    config = b2apiex->GetConfig();

    // "From"wb_ mailaddress 𒊏oA|C^XgɊi[
    string from;
    if (mail->getHeader("Resent-Message-Id").length()) {
        from = mail->getHeader("Resent-From");
    } else {
        from = mail->getHeader("From");
    }

    CPointerList lstAddr;
    addAddressList(lstAddr, from);

    // i[ mailaddress Ƃ return
    CPointerItem* pItem = lstAddr.GetTop();
    if (pItem == NULL) {
        return false;
    }

    // Clean upKvȂ̂`
    PGPKeySetRef defaultKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef foundUserKeySet = kInvalidPGPKeySetRef;
    PGPOptionListRef pasdlgOptionList = kInvalidPGPOptionListRef;
    PGPOptionListRef encodeOptionList = kInvalidPGPOptionListRef;
    PGPKeyRef signingKey = kInvalidPGPKeyRef;
    char *lpPassphrase = NULL;
    LPSTR lpArea = NULL;

    try {
        // Default Key RingJ
        PGPError err = PGPOpenDefaultKeyRings(context, FALSE, &defaultKeySet);
        PGPCheckSdkError(err, "The Error occured in PGPOpenDefaultKeyRings.");

        // e mailaddress ɑΉL[܂Ƃ߂Ēo
        getKeySet(pItem, defaultKeySet, foundUserKeySet);

        if (!getPassphraseFromSignCache(foundUserKeySet, signingKey, lpPassphrase)) {

            // pXt[Y͂̃IvV\z
            PGPUInt32 initialValueOfPgpMime = (pgpmime) ? TRUE : FALSE;
            PGPUInt32 resultValueOfPgpMime;

            err = PGPBuildOptionList(
                context,
                &pasdlgOptionList,
                PGPOUIOutputPassphrase(context, &lpPassphrase),
                PGPOUIParentWindowHandle(context, hWnd),
                PGPOUIVerifyPassphrase(context, TRUE),
                PGPOUIDialogOptions(context,
                    PGPOUICheckbox(context, 1, "PGP/MIME_RFC2015", NULL, initialValueOfPgpMime, &resultValueOfPgpMime,
                        PGPOLastOption(context)),
                    PGPOLastOption(context)),
                PGPOLastOption(context)
                );

            // From̃[AhXɑΉ閧邩H
            if (countKeys(foundUserKeySet) > 0) {
                // ȂA擪ɎgpftHgƂ
                PGPKeyRef signDefaultKey = NULL;
                getKeyRef(foundUserKeySet, signDefaultKey);
                err = PGPAppendOptionList(
                        pasdlgOptionList,
                        PGPOUIDefaultKey(context, signDefaultKey),
                        PGPOLastOption(context)
                        );
                PGPCheckSdkError(err, "The Error occured in AppendOptionList.");
            }

            // Passphrase ͂_CAO\
            err = PGPSigningPassphraseDialog(
                    context,
                    defaultKeySet,
                    &signingKey,
                    pasdlgOptionList,
                    PGPOLastOption(context)
                    );

            PGPCheckUserAbort(err, "User Canceled");
            PGPCheckSdkError(err, "The Error occured in SigningPassphraseDialog.");

            pgpmime = (resultValueOfPgpMime == TRUE);
        }

        // Ώۂ̃eLXg擾
        string text = mail->getPgpOriginalText(hWnd, pgpmime);
        if (text.size() == 0) {
            throw PGPUserError("User's mail don't have text.");
        }

        /*
            FILE* fp;
            fp = fopen("E:\\syou\\mail1.txt", "wb");
            fwrite(text.c_str(), text.size(), 1, fp);
            fclose(fp);
        //*/

        // ̃IvV\z
        PGPSize outputSize = 0;
        err = PGPBuildOptionList(
                context,
                &encodeOptionList,
                PGPOInputBuffer(context, text.c_str(), text.size()),
                PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &outputSize),
                PGPOVersionString(context, mes->getsfr(IDS_PGPB2_VERSION).c_str()),
                    PGPOSignWithKey(context, signingKey,
                        PGPOPassphrase(context, lpPassphrase),
                        PGPOLastOption(context)),
                PGPOLastOption(context)
                );

        PGPCheckSdkError(err, "The Error occured in BuildOptionList.");

        if (pgpmime) {
            // PGP/MIMEp̃IvVǉ
            err = PGPAppendOptionList(
                    encodeOptionList,
                    PGPOArmorOutput(context, TRUE),
                    PGPODetachedSig(context,
                        PGPOLastOption(context)),
                    PGPOLastOption(context)
                    );
        }
        else {
            // PGP/MIMEȊOp̃IvVǉ
            err = PGPAppendOptionList(
                    encodeOptionList,
                    PGPOClearSign(context, TRUE),
                    PGPOLastOption(context)
                    );
        }

        PGPCheckSdkError(err, "The Error occured in AppendOptionList.");

        err = PGPEncode(context, encodeOptionList, PGPOLastOption(context));

        if (IsPGPError(err) || lpArea == NULL) {
            throw PGPSdkError(err, "The Error occured in Encode.");
        }

        if (pgpmime) {
            char szBoundary[1024];
            char szData[8192];
            char szHash[20];
            time_t t;

            if (!getHashAlgorithm(signingKey, szHash)) {
                throw PGPSdkError(err, "The Error occured in getHashAlgorithm.");
            }

            time(&t);
            sprintf(szBoundary, "===[PGP/MIME_RFC2015]===%08X.%04X===", (DWORD)t, &t);
            sprintf(szData, "multipart/signed;\r\n boundary=\"%s\";\r\n protocol=\"application/pgp-signature\"; micalg=pgp-%s",
                szBoundary, szHash);
            mail->setHeader("Content-Type", szData);
            mail->setHeader("Content-Transfer-Encoding", "7bit");
            mail->clearBody();

            BkMail* child1 = mail->setChild(new BkMail());
            child1->fromString(text);

            BkMail* child2 = mail->addChild(new BkMail());
            child2->setHeader("Content-Type", "application/pgp-signature");
            child2->setHeader("Content-Transfer-Encoding", "7bit");
            child2->pushBodyBack(lpArea);
        }
        else {
            mail->setText(lpArea);
        }

        result = true;

    } catch (PGPSdkError& sdkError) {
        std::string message = sdkError.getErrorSpecification();
        ::MessageBox(hWnd, message.c_str(), "PGPB2 - Error", MB_OK | MB_ICONERROR);
    } catch (PGPUserError& userError) {
        b2api->SetMessageText(hWnd, userError.what());
    }

    // Save passphrase for sign
    if (lpPassphrase) {
        cache->setSignPassphrase(signingKey, lpPassphrase);
    }

    // Clean up
    if (lpArea) {
        PGPFreeData(lpArea);
    }
    if (PGPOptionListRefIsValid(pasdlgOptionList)) {
        PGPFreeOptionList(pasdlgOptionList);
    }
    if (PGPOptionListRefIsValid(encodeOptionList)) {
        PGPFreeOptionList(encodeOptionList);
    }
    if (PGPKeySetRefIsValid(foundUserKeySet)) {
        PGPFreeKeySet(foundUserKeySet);
    }
    if (PGPKeySetRefIsValid(defaultKeySet)) {
        PGPFreeKeySet(defaultKeySet);
    }

    return result;
}



////////////////////////////////////////////////////////////////////////
// PGPÍ
bool Pgpb2::encryptSigning(HWND hWnd, PgpMail* mail)
{
    // 
    bool result = false;

    // Config擾
    config = b2apiex->GetConfig();

    // "To"A"Cc"A"Bcc"̊ewb_ mailaddress 𒊏oA|C^XgɊi[B
    string to;
    string cc;
    string bcc;
    string from;

    if (mail->getHeader("Resent-Message-Id").length()) {
        to = mail->getHeader("Resent-To");
        cc = mail->getHeader("Resent-Cc");
        bcc = mail->getHeader("Resent-Bcc");
        from = mail->getHeader("Resent-From");
    }else {
        to = mail->getHeader("To");
        cc = mail->getHeader("Cc");
        bcc = mail->getHeader("Bcc");
        from = mail->getHeader("From");
    }

    // Bcc̋Lq
    if (config.isWarningBccExist() && !bcc.empty()) {
        int res = ::MessageBox(hWnd, mes->getsfr(IDS_WARNING_BCCEXIST).c_str(),
            "PGPB2 - Warning", MB_YESNOCANCEL | MB_ICONWARNING | MB_DEFBUTTON2);
        if (res == IDNO) {
            bcc.erase();
        } else if (res ==IDCANCEL) {
            return false;
        }
    }

    CPointerList lstToAddr;
    CPointerList lstFromAddr;
    addAddressList(lstToAddr, to);
    addAddressList(lstToAddr, cc);
    addAddressList(lstToAddr, bcc);
    addAddressList(lstFromAddr, from);

    CPointerItem* pToItem = lstToAddr.GetTop();
    CPointerItem* pFromItem = lstFromAddr.GetTop();
    if (pToItem == NULL || pFromItem == NULL) {
        return false;
    }

    PGPKeySetRef defaultKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef foundToUserKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef foundFromUserKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef encryptKeySet = kInvalidPGPKeySetRef;
    PGPKeyRef signingKey = kInvalidPGPKeyRef;
    PGPOptionListRef pasdlgOptionList = kInvalidPGPOptionListRef;
    PGPOptionListRef encodeOptionList = kInvalidPGPOptionListRef;
    LPSTR lpPassphrase = NULL;
    LPSTR lpArea = NULL;

    try {
        // ǉƂāADefault KeySet擾
        PGPError err = PGPOpenDefaultKeyRings(context, FALSE, &defaultKeySet);
        PGPCheckSdkError(err, "The Error occured in OpenDefaultKeyRings.");

        getKeySet(pToItem, defaultKeySet, foundToUserKeySet);
        getKeySet(pFromItem, defaultKeySet, foundFromUserKeySet);

        // Default Recipient擾
        std::vector<PGPRecipientSpec> spec;
        int numberOfDefault = getDefaultRecipients(foundToUserKeySet, spec);
        if (numberOfDefault == 0) {
            throw PGPUserError("Not found any key of recipients in Default Key Ring.");
        }

        PGPUInt32 initialValueOfPgpMime = (pgpmime) ? TRUE : FALSE;
        PGPUInt32 resultValueOfPgpMime;
        PGPUInt32 initialValueOfConv = FALSE;
        PGPUInt32 resultValueOfConv;
        err = PGPRecipientDialog(
                context,
                defaultKeySet,
                TRUE,
                &encryptKeySet,
                PGPOUIParentWindowHandle(context, hWnd),
                PGPOUIDialogOptions(context,
                    PGPOUICheckbox(context, 1, "PGP/MIME_RFC2015", NULL, initialValueOfPgpMime, &resultValueOfPgpMime,
                        PGPOLastOption(context)),
                    PGPOUICheckbox(context, 2, "Conventional &Encryption", NULL,
                        initialValueOfConv, &resultValueOfConv,
                        PGPOLastOption(context)), 
                    PGPOLastOption(context)),
                PGPOUIDefaultRecipients(context, numberOfDefault, &spec[0]),
                PGPOLastOption(context)
                );


        PGPCheckUserAbort(err, "User Canceled.");
        PGPCheckSdkError(err, "The Error occured in RecipientDialog.");

        pgpmime = (resultValueOfPgpMime == TRUE);

        err = PGPBuildOptionList(
                context,
                &encodeOptionList,
                PGPOVersionString(context, mes->getsfr(IDS_PGPB2_VERSION).c_str()),
                PGPOArmorOutput(context, TRUE),
                PGPOLastOption(context)
                );

        PGPCheckSdkError(err, "The error occured in PGPBuildOptionList.");
       
        if (resultValueOfConv == TRUE) {
            appendConventionalEncryptionOptionList(hWnd, encodeOptionList);
        } else {
            appendEncryptionOptionList(encryptKeySet, encodeOptionList);
        }

        if (!getPassphraseFromSignCache(foundFromUserKeySet, signingKey, lpPassphrase)) {

            err = PGPBuildOptionList(
                context,
                &pasdlgOptionList,
                PGPOUIParentWindowHandle(context, hWnd),
                PGPOUIOutputPassphrase(context, &lpPassphrase),
                PGPOUIVerifyPassphrase(context, TRUE),
                PGPOLastOption(context)
                );

            if (countKeys(foundFromUserKeySet) > 0) {
                PGPKeyRef signDefaultKey = NULL;
                getKeyRef(foundFromUserKeySet, signDefaultKey);
                err = PGPAppendOptionList(
                        pasdlgOptionList,
                        PGPOUIDefaultKey(context, signDefaultKey),
                        PGPOLastOption(context)
                        );
                PGPCheckSdkError(err, "The Error occured in AppendOptionList.");
            }

            err = PGPSigningPassphraseDialog(
                    context,
                    defaultKeySet,
                    &signingKey,
                    pasdlgOptionList,
                    PGPOLastOption(context)
                    );

            PGPCheckUserAbort(err, "User Canceled.");
            PGPCheckSdkError(err, "The Error occured in SigningPassphraseDialog.");
        }

        string text = mail->getPgpOriginalText(hWnd, pgpmime);
        if (text.size() == 0) {
            throw PGPUserError("User's mail don't have text.");
        }

        PGPSize outputSize = 0;
        err = PGPEncode(
                context,
                encodeOptionList,
                PGPOInputBuffer(context, text.c_str(), text.size()),
                PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &outputSize),
                PGPOSignWithKey(context, signingKey,
                    PGPOPassphrase(context, lpPassphrase),
                    PGPOLastOption(context)),
                PGPOLastOption(context)
                );

        if (IsPGPError(err) || lpArea == NULL) {
            throw PGPSdkError(err, "The Error occured in Encode.");
        }

        if (pgpmime) {
            char szBoundary[1024];  // MIMEboundary ؂蕶
            char szData[8192];
            time_t t;
            time(&t);   // ݂̎擾 boundaryɖߍ
            sprintf(szBoundary, "===[PGP/MIME_RFC2015]===%08X.%04X===", (DWORD)t, &t);
            sprintf(szData, "multipart/encrypted;\r\n boundary=\"%s\";\r\n protocol=\"application/pgp-encrypted\"", szBoundary);
            mail->setHeader("Content-Type", szData);
            mail->setHeader("Content-Transfer-Encoding", "7bit");
            mail->clearBody();

            BkMail* child1;
            child1 = mail->setChild(new BkMail());
            child1->setHeader("Content-Type", "application/pgp-encrypted");
            child1->setHeader("Content-Transfer-Encoding", "7bit");
            child1->pushBodyBack("Version: 1\r\n");

            BkMail* child2;
            child2 = mail->addChild(new BkMail());
            child2->setHeader("Content-Type", "application/octet-stream");
            child2->setHeader("Content-Transfer-Encoding", "7bit");
            child2->pushBodyBack(lpArea);
        }
        else {
            mail->setText(lpArea);
        }

        result = true;

    } catch (PGPSdkError& sdkError) {
        std::string message = sdkError.getErrorSpecification();
        ::MessageBox(hWnd, message.c_str(), "PGPB2 - Error", MB_OK | MB_ICONERROR);
    } catch (PGPUserError& userError) {
        b2api->SetMessageText(hWnd, userError.what());
    }

    // Save passphrase for sign
    if (lpPassphrase) {
        cache->setSignPassphrase(signingKey, lpPassphrase);
    }

    // Clean up
    if (lpArea) {
        PGPFreeData(lpArea);
    }
    if (PGPOptionListRefIsValid(pasdlgOptionList)) {
        PGPFreeOptionList(pasdlgOptionList);
    }
    if (PGPOptionListRefIsValid(encodeOptionList)) {
        PGPFreeOptionList(encodeOptionList);
    }
    if (PGPKeySetRefIsValid(encryptKeySet)) {
        PGPFreeKeySet(encryptKeySet);
    }
    if (PGPKeySetRefIsValid(foundFromUserKeySet)) {
        PGPFreeKeySet(foundFromUserKeySet);
    }
    if (PGPKeySetRefIsValid(foundToUserKeySet)) {
        PGPFreeKeySet(foundToUserKeySet);
    }
    if (PGPKeySetRefIsValid(defaultKeySet)) {
        PGPFreeKeySet(defaultKeySet);
    }

    return result;
}


////////////////////////////////////////////////////////////////////////
// PGPJYt
bool Pgpb2::publickey(HWND hWnd)
{
    bool result = false;

    // Config擾
    config = b2apiex->GetConfig();

    PGPKeySetRef defaultKeySet = kInvalidPGPKeySetRef;
    PGPKeySetRef attachementKeySet = kInvalidPGPKeySetRef;
    PGPFileSpecRef fileSpec = kInvalidPGPFileSpecRef;

    try {
        PGPError err = PGPOpenDefaultKeyRings(context, FALSE, &defaultKeySet);
        if (IsPGPError(err)) {
            throw PGPSdkError(err, "The error occured in PGPOpenDefaultKeyRings.");
        }

        err = PGPRecipientDialog(
                context,
                defaultKeySet,
                TRUE,
                &attachementKeySet,
                PGPOUIParentWindowHandle(context, hWnd),
                PGPOLastOption(context)
                );

        PGPCheckUserAbort(err, "User Canceled.");
        PGPCheckSdkError(err, "The Error occured in PGPRecipientDialog.");

        std::string fullpath;
        fullpath = b2api->GetTempFolder();
        fullpath += getExportKeySetFileName(attachementKeySet);

        err = PGPNewFileSpecFromFullPath(context, fullpath.c_str(), &fileSpec);
        if (IsPGPError(err)) {
            throw PGPSdkError(err, "The Error occured in PGPNewFileSpecFromFullPath.");
        }

        PGPExportFormat exportformat = kPGPExportFormat_Basic;
        PGPSize outputSize = 0;
        err = PGPExportKeySet(
                  attachementKeySet,
                  PGPOOutputFile(context, fileSpec),
                  PGPOExportFormat(context, exportformat),
                  PGPOVersionString(context, mes->getsfr(IDS_PGPB2_VERSION).c_str()),
                  PGPOExportPrivateKeys(context, FALSE),
                  PGPOLastOption(context)
                  );

        /*
        char* msg = new char[1024];
        PGPGetErrorString(err, 1024, msg);
        delete [] msg;
        */

        PGPCheckSdkError(err, "The Error occured in ExportKeySet.");

        b2api->CompAttachFile(hWnd, fullpath.c_str(), "application/pgp-keys");
        ::DeleteFile(fullpath.c_str());

        result = true;

    } catch (PGPSdkError& sdkError) {
        std::string message = sdkError.getErrorSpecification();
        ::MessageBox(hWnd, message.c_str(), "PGPB2 - Error", MB_OK | MB_ICONERROR);
    } catch (PGPUserError& userError) {
        b2api->SetMessageText(hWnd, userError.what());
    }

    // Clean up
    if (PGPFileSpecRefIsValid(fileSpec)) {
        PGPFreeFileSpec(fileSpec);
    }
    if (PGPKeySetRefIsValid(attachementKeySet)) {
        PGPFreeKeySet(attachementKeySet);
    }
    if (PGPKeySetRefIsValid(defaultKeySet)) {
        PGPFreeKeySet(defaultKeySet);
    }

    return result;
}

#pragma warning(pop) /* restore previous warning */
