/////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2Thread.cpp
//
// Copyright(C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2Thread.cpp,v $
 * Revision 1.4  2001/01/20 07:40:17  syou
 * - Í̍ہAToACcABcc̃AhXDefault RecipientƂĈ悤ɂA
 *   ܂Cӂ̌JgĈÍł悤ɂB܂ADefault Recipient
 *   Default Private Key̒ǉ\ɂIvV݂BA
 *   ͂Ȃr(^^;
 *
 * Revision 1.3  2000/11/23 07:17:58  syou
 * - DllMainŎqXbh쐬Ă߁APGPB2[hĂȂԂŁA
 *   B2̃vOC̑I_CAOJƂAB2ƂɗĂ
 *   oOCBWindows98ŏ؂̃bZ[WpƂȂĂ̂C
 *   BlXg`ɂȂĂPGP/MIME[̕ƌ؂肭oȂ
 *   oOPgpb2::decodePgpMailPartPgpb2::decodePgpMailPart2ŏCB
 *   Decode܂̃WbŇccłB
 *   PGP/MIMEbZ[W̕ƌ؋@\ǉB،ʂɂẮAƂ肠
 *   PGPlogɕ\悤ɂ݂܂Bo̓bZ[W\[X֒ǕB
 *
 * Revision 1.2  2000/11/08 16:50:47  syou
 * - PGPlogɃbZ[Wo͂邽߂ɁAclass PGPlogVK쐬B
 *   FXKvɂȂ肻Ȃ̂ŁAclass CriticalSectionVK쐬B
 *
 * Revision 1.1  2000/11/07 15:57:19  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 *
 */


/////////////////////////////////////////////////////////////////////////////////
//
#include "Pgpb2Thread.h"


/////////////////////////////////////////////////////////////////////////////////
//
DWORD Pgpb2Thread::tlsid = 0;


/////////////////////////////////////////////////////////////////////////////////
//
Pgpb2Thread::Pgpb2Thread(HINSTANCE initInstance, DWORD initTlsid)
{
    instance = initInstance;
    tlsid = initTlsid;
    pass = TRUE;
    pgpb2 = NULL;
    threadHandle = NULL;
    b2api = B2APIEx::InstanceEx();
}


Pgpb2Thread::~Pgpb2Thread()
{
    if (threadHandle) {
        ::CloseHandle(threadHandle);
    }
}


bool Pgpb2Thread::run()
{
    if (threadHandle) {
        return false;
    }

    unsigned threadID;
    threadHandle = (HANDLE)_beginthreadex(NULL, 0, Pgpb2Thread::threadStart, this, 0, &threadID);
    return (threadHandle != 0);
}


void Pgpb2Thread::stop()
{
    ::SendMessage(windowOfPgpb2, WM_DESTROY, 0, 0);
}


bool Pgpb2Thread::isAcctive()
{
    if (threadHandle) {
        return false;
    }

    DWORD exitCode;
    return (::GetExitCodeThread(threadHandle, &exitCode) == TRUE &&
            exitCode == STILL_ACTIVE);
}


void Pgpb2Thread::waitForThreadEnd()
{
    if (threadHandle) {
        ::WaitForSingleObject(threadHandle, INFINITE);
    }
}


/////////////////////////////////////////////////////////////////////////////////
//
unsigned __stdcall Pgpb2Thread::threadStart(void* threadObject)
{
    Pgpb2Thread* pgpb2Thread = static_cast<Pgpb2Thread*>(threadObject);
    pgpb2Thread->main();
    return 0;
}


void Pgpb2Thread::main()
{
    MSG msg;
    registerWindowClass();
    if (initTls(this) && initPGPB2() && initWindow())
    {
        while(::GetMessage(&msg, NULL, 0, 0))
        {
            ::TranslateMessage(&msg);
            ::DispatchMessage(&msg);
        }
    }

    // Clean up
    dispose();
}


ATOM Pgpb2Thread::registerWindowClass()
{
    WNDCLASSEX wcex;

    wcex.cbSize         = sizeof(WNDCLASSEX);
    wcex.style          = 0;//CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc    = (WNDPROC)Pgpb2Thread::WndProc;
    wcex.cbClsExtra     = 0;
    wcex.cbWndExtra     = 0;
    wcex.hInstance      = instance;
    wcex.hIcon          = 0;//LoadIcon(hInstance, (LPCTSTR)IDI_TESTES);
    wcex.hCursor        = 0;//LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground  = 0;//(HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName   = 0;//(LPCSTR)IDC_TESTES;
    wcex.lpszClassName  = "PGPB2HIDECLASS";
    wcex.hIconSm        = 0;//LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

    return ::RegisterClassEx(&wcex);
}


bool Pgpb2Thread::initTls(Pgpb2Thread* pointer)
{
    return (::TlsSetValue(tlsid, pointer) == TRUE);
}


bool Pgpb2Thread::initPGPB2()
{
    bool result = false;

    try {
        pgpb2 = new Pgpb2(instance);
        result = true;
    } catch (PGPSdkError& sdkError) {
        std::string message = sdkError.getErrorSpecification();
        ::MessageBox(NULL, message.c_str(), "PGPB2 - Error", MB_OK | MB_ICONERROR);
    } catch (...) {
    }

    return result;
}


bool Pgpb2Thread::initWindow()
{
    windowOfPgpb2 = ::CreateWindow("PGPB2HIDECLASS", 0, 0, 0, 0, 0, 0, NULL, NULL, instance, NULL);
    if(!windowOfPgpb2) {
        return false;
    }

    ::ShowWindow(windowOfPgpb2, SW_HIDE);
    return true;
}


void Pgpb2Thread::dispose()
{
    delete pgpb2;
    pgpb2 = NULL;

    if (tlsid != TLS_OUT_OF_INDEXES) {
        initTls(NULL);
    }
}


/////////////////////////////////////////////////////////////////////////////////
//
LRESULT CALLBACK Pgpb2Thread::WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    Pgpb2Thread* pgpb2Thread = static_cast<Pgpb2Thread*>(TlsGetValue(tlsid));
    if (pgpb2Thread) {
        return pgpb2Thread->windowProc(hWnd, msg, wParam, lParam);
    }
    return ::DefWindowProc(hWnd, msg, wParam, lParam);
}


LRESULT Pgpb2Thread::windowProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch(msg)
    {
        case WM_DESTROY:
            ::PostQuitMessage(0);
            break;
        case WM_PGPB2_ENCRYPT:
            {
                bool encode = pgpb2->encrypt(recipentWindow, mail);
                if (encode) {
                    if (pgpb2->isPgpmime()) {
                        b2api->CompSetSource(recipentWindow, mail->toString().c_str());
                    }
                    else {
                        b2api->CompSetText(recipentWindow, 0, mail->getTextWithJpnProc().c_str());
                    }
                }
                delete mail;
                ::EnableWindow(recipentWindow, PGPB2_ENTERTRUE);
                leave();
            }
            break;
        case WM_PGPB2_SIGINING:
            {
                bool encode = pgpb2->signing(recipentWindow, mail);
                if (encode) {
                    if (pgpb2->isPgpmime()) {
                        b2api->CompSetSource(recipentWindow, mail->toString().c_str());
                    }
                    else {
                        b2api->CompSetText(recipentWindow, 0, mail->getTextWithJpnProc().c_str());
                    }
                }
                delete mail;
                ::EnableWindow(recipentWindow, TRUE);
                leave();
            }
            break;
        case WM_PGPB2_ENCRYPTSIGINING:
            {
                bool encode = pgpb2->encryptSigning(recipentWindow, mail);
                if (encode) {
                    if (pgpb2->isPgpmime()) {
                        b2api->CompSetSource(recipentWindow, mail->toString().c_str());
                    }
                    else {
                        b2api->CompSetText(recipentWindow, 0, mail->getTextWithJpnProc().c_str());
                    }
                }
                delete mail;
                ::EnableWindow(recipentWindow, TRUE);
                leave();
            }
            break;
        case WM_PGPB2_PUBLICKEY:
            {
				bool encode = pgpb2->publickey(recipentWindow);
                delete mail;
                ::EnableWindow(recipentWindow, TRUE);
                leave();
            }
            break;//*/
        case WM_PGPB2_DECODEPGPMIME:
            {
                bool decode = pgpb2->decodePgpMime(recipentWindow, mail);
                if (decode) {
                    b2api->SetSource("TEMP", mail->toString().c_str());
                }
                delete mail;
                ::EnableWindow(recipentWindow, TRUE);
                leave();
            }
            break;
        case WM_PGPB2_DECODENOTPGPMIME:
            {
                bool decode = pgpb2->decodeNotPgpMime(recipentWindow, mail);
                if (decode) {
                    b2api->SetText(-2, mail->getTextWithJpnProc().c_str());
                }
                delete mail;
                ::EnableWindow(recipentWindow, TRUE);//*/
                leave();
            }
            break;
        case WM_PGPB2_CLEARPASSPHRASECACHE:
            {
                pgpb2->clearPassphraseCache();
                ::EnableWindow(recipentWindow, PGPB2_ENTERTRUE);
                leave();
            }
            break;
        default:
            return ::DefWindowProc(hWnd, msg, wParam, lParam);
   }
   return 0;
}


/////////////////////////////////////////////////////////////////////////////////
//
bool Pgpb2Thread::enter()
{
    if (::InterlockedExchange(&pass, PGPB2_ENTERFALSE) != PGPB2_ENTERTRUE) {
        return false;
    }
    return true;
}


void Pgpb2Thread::leave()
{
    ::InterlockedExchange(&pass, PGPB2_ENTERTRUE);
}


void Pgpb2Thread::set(HWND newRecipentWindow, PgpMail* newMail)
{
    recipentWindow = newRecipentWindow;
    mail = newMail;
}


/////////////////////////////////////////////////////////////////////////////////
//
/**
 * Í
 */
bool Pgpb2Thread::pgpEncrypt(HWND hWnd, PgpMail* mail)
{
    if (!enter()) {
        return false;
    }
    set(hWnd, mail);
    ::EnableWindow(hWnd, FALSE);
    ::PostMessage(windowOfPgpb2, WM_PGPB2_ENCRYPT, 0, 0);
    return true;
}


/**
 * 
 */
bool Pgpb2Thread::pgpSigning(HWND hWnd, PgpMail* mail)
{
    if (!enter()) {
        return false;
    }
    set(hWnd, mail);
    ::EnableWindow(hWnd, FALSE);
    ::PostMessage(windowOfPgpb2, WM_PGPB2_SIGINING, 0, 0);
    return true;
}


/**
 * ÍƏ
 */
bool Pgpb2Thread::pgpEncryptSigning(HWND hWnd, PgpMail* mail)
{
    if (!enter()) {
        return false;
    }
    set(hWnd, mail);
    ::EnableWindow(hWnd, FALSE);
    ::PostMessage(windowOfPgpb2, WM_PGPB2_ENCRYPTSIGINING, 0, 0);
    return true;
}


/**
 * JYt
 */
bool Pgpb2Thread::pgpPublickey(HWND hWnd)
{
    if (!enter()) {
        return false;
    }
    set(hWnd, NULL);
    ::EnableWindow(hWnd, FALSE);
    ::PostMessage(windowOfPgpb2, WM_PGPB2_PUBLICKEY, 0, 0);
    return true;
}
//*/

/**
 * ƌ
 */
bool Pgpb2Thread::pgpDecodePgpMime(HWND hWnd, PgpMail* mail)
{
    if (!enter()) {
        return false;
    }
    set(hWnd, mail);
    ::EnableWindow(hWnd, FALSE);
    ::PostMessage(windowOfPgpb2, WM_PGPB2_DECODEPGPMIME, 0, 0);
    return true;
}


/**
 * ƌ؂͂ǂ낤H
 */
bool Pgpb2Thread::pgpDecodeNotPgpMime(HWND hWnd, PgpMail* mail)
{
    if (!enter()) {
        return false;
    }
    set(hWnd, mail);
    ::EnableWindow(hWnd, FALSE);
    ::PostMessage(windowOfPgpb2, WM_PGPB2_DECODENOTPGPMIME, 0, 0);
    return true;
}


/**
 *  ꎞۑpXt[Y
 */
bool Pgpb2Thread::pgpClearPassphraseCache(HWND hWnd)
{
    if (!enter()) {
        return false;
    }
    set(hWnd, NULL);
    ::EnableWindow(hWnd, FALSE);
    ::PostMessage(windowOfPgpb2, WM_PGPB2_CLEARPASSPHRASECACHE, 0, 0);
    return true;
}
//*/

/////////////////////////////////////////////////////////////////////////////////
//
