/**
 * @file SetupDialog.cpp
 * @brief PGPB2̐ݒ_CAO
 * @author  Copyright (C) 2002 YUGA <yuga@ops.dti.ne.jp>
 * $Date: $
 * $Revision: $
 *
 */


/////////////////////////////////////////////////////////////////////////////////
//
#include "SetupDialog.h"


/////////////////////////////////////////////////////////////////////////////////
//
#define SetSelNumber(id, i) sel[(((id) == IDC_VERIFY_LISTVIEW_GOODCOL)? 0:1)] = (i)
#define GetSelNumber(id)    sel[(((id) == IDC_VERIFY_LISTVIEW_GOODCOL)? 0:1)]


/////////////////////////////////////////////////////////////////////////////////
//
HINSTANCE g_hInst;
ConfigMgr* conMgr;
int sel[2] = { 0, 0};


/////////////////////////////////////////////////////////////////////////////////
//
void SetupDialog(HINSTANCE hInstance, HWND hWnd, ConfigMgr* initConfigMgr)
{
    g_hInst = hInstance;
    conMgr = initConfigMgr;
    int nRC = DialogBox(hInstance,
            MAKEINTRESOURCE(IDD_PGPB2_SETUP), hWnd, (DLGPROC)PGPB2SetupProc);
}


BOOL CALLBACK PGPB2SetupProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch (msg){
    case WM_COMMAND:
        {
            WORD id, code;
            id = LOWORD(wParam); code = HIWORD(wParam);

            switch (id) {
            case IDOK:
                {
                    Config config = conMgr->get();

                    // Í
                    bool encryptDefaultKey;
                    bool warningBccExist;

                    encryptDefaultKey = BMGetCheck(hWnd, IDC_ENCRYPT_DEFAULTKEY);
                    warningBccExist   = BMGetCheck(hWnd, IDC_ENCRYPT_WARNINGBCC);

                    config.setEncryptDefaultKey(encryptDefaultKey);
                    config.setWarningBccExist(warningBccExist);

                    // pXt[Y
                    bool       saveDecryptPassphrase;
                    bool       saveSignPassphrase;
                    SYSTEMTIME stDecrypt;
                    SYSTEMTIME stSign;

                    saveDecryptPassphrase = BMGetCheck(hWnd, IDC_SAVE_DECRYPT_PASS);
                    saveSignPassphrase    = BMGetCheck(hWnd, IDC_SAVE_SIGN_PASS);

                    DTMGetSystemTime(hWnd, IDC_SAVE_DECRYPT_PASS_TIMEPICKER, &stDecrypt);
                    DTMGetSystemTime(hWnd, IDC_SAVE_SIGN_PASS_TIMEPICKER,    &stSign);

                    config.setSaveDecryptPassphrase(saveDecryptPassphrase);
                    config.setSaveSignPassphrase(saveSignPassphrase);
                    config.setSaveTimeDecryptPassphrase(stDecrypt);
                    config.setSaveTimeSignPassphrase(stSign);

                    // ،
                    bool     usePGPlog;
                    bool     displayVerificationResultOnListView;
                    DWORD    dtVerificationResult;
                    COLORREF dcVerificationCorrect;
                    COLORREF dcVerificationInCorrect;
                    bool     eraseBackgroundOfListView;

                    char buffer[100];

                    usePGPlog                           = BMGetCheck(hWnd, IDC_VERIFY_PGPLOG);
                    displayVerificationResultOnListView = BMGetCheck(hWnd, IDC_VERIFY_LISTVIEW);
                    WMGetText(hWnd, IDC_VERIFY_LISTVIEW_MS, 10, &buffer[0]);
                    dtVerificationResult      = atoi(&buffer[0]);
                    dcVerificationCorrect     = CBGetItemData(hWnd, IDC_VERIFY_LISTVIEW_GOODCOL, CBGetCurSel(hWnd, IDC_VERIFY_LISTVIEW_GOODCOL));
                    dcVerificationInCorrect   = CBGetItemData(hWnd, IDC_VERIFY_LISTVIEW_BADCOL, CBGetCurSel(hWnd, IDC_VERIFY_LISTVIEW_BADCOL));
                    eraseBackgroundOfListView = BMGetCheck(hWnd, IDC_VERIFY_LISTVIEW_ERASEBACK);

                    config.setUsePGPlog(usePGPlog);
                    config.setDisplayVerificationResultOnListView(displayVerificationResultOnListView);
                    config.setDisplayTimeVerificationResult(dtVerificationResult);
                    config.setDisplayColorVerificationCorrect(dcVerificationCorrect);
                    config.setDisplayColorVerificationInCorrect(dcVerificationInCorrect);
                    config.setEraseBackgroundOfListView(eraseBackgroundOfListView);

                    // Config̃Zbg
                    conMgr->set(config);
                    conMgr->save();

                    EndDialog(hWnd, IDOK);
                    return TRUE;
                }
                break;

            case IDCANCEL:
                {
                    EndDialog(hWnd, id);
                    return TRUE;
                }
                break;

            case IDC_SAVE_DECRYPT_PASS:
                {
                    bool enable = BMGetCheck(hWnd, id);
                    EnableDlgItem(hWnd, IDC_SAVE_DECRYPT_PASS_TIMEPICKER, enable);
                    return TRUE;
                }
                break;

            case IDC_SAVE_SIGN_PASS:
                {
                    bool enable = BMGetCheck(hWnd, id);
                    EnableDlgItem(hWnd, IDC_SAVE_SIGN_PASS_TIMEPICKER, enable);
                    return TRUE;
                }
                break;

            case IDC_VERIFY_LISTVIEW:
                {
                    bool enable = BMGetCheck(hWnd, id);
                    EnableDlgItem(hWnd, IDC_VERIFY_LISTVIEW_MS,        enable);
                    EnableDlgItem(hWnd, IDC_VERIFY_LISTVIEW_GOODCOL,   enable);
                    EnableDlgItem(hWnd, IDC_VERIFY_LISTVIEW_BADCOL,    enable);
                    EnableDlgItem(hWnd, IDC_VERIFY_LISTVIEW_ERASEBACK, enable);
                }
                break;

            case IDC_VERIFY_LISTVIEW_GOODCOL:
            case IDC_VERIFY_LISTVIEW_BADCOL:
                {
                    if (code == CBN_SELENDOK) {
                        if (CBGetCurSel(hWnd, id) == 16) {
                            OnChooseColor(hWnd, id);
                        }
                        else {
                            SetSelNumber(id, CBGetCurSel(hWnd, id));
                        }
                    }
                    return TRUE;
                }
                break;

            default:
                break;
            }

            return TRUE;
        }
        break;

    case WM_INITDIALOG:
        {
            Config config = conMgr->get();

            // Í
            BMSetCheck(hWnd, IDC_ENCRYPT_DEFAULTKEY, config.isEncryptDefaultKey());
            BMSetCheck(hWnd, IDC_ENCRYPT_WARNINGBCC, config.isWarningBccExist());

            // pXt[Y
            const SYSTEMTIME& stDecrypt = config.getSaveTimeDecryptPassphrase();
            const SYSTEMTIME& stSign    = config.getSaveTimeSignPassphrase();

            BMSetCheck(hWnd, IDC_SAVE_DECRYPT_PASS,  config.isSaveDecryptPassphrase());
            DTMSetSystemTime(hWnd, IDC_SAVE_DECRYPT_PASS_TIMEPICKER, &stDecrypt);
            DTMSetFormat(hWnd, IDC_SAVE_DECRYPT_PASS_TIMEPICKER, "HH : mm : ss");
            BMSetCheck(hWnd, IDC_SAVE_SIGN_PASS, config.isSaveSignPassphrase());
            DTMSetSystemTime(hWnd, IDC_SAVE_SIGN_PASS_TIMEPICKER, &stSign);
            DTMSetFormat(hWnd, IDC_SAVE_SIGN_PASS_TIMEPICKER, "HH : mm : ss");

            EnableDlgItem(hWnd, IDC_SAVE_DECRYPT_PASS_TIMEPICKER, config.isSaveDecryptPassphrase());
            EnableDlgItem(hWnd, IDC_SAVE_SIGN_PASS_TIMEPICKER,    config.isSaveSignPassphrase());

            // ،
            BMSetCheck(hWnd, IDC_VERIFY_PGPLOG,   config.isUsePGPlog());
            BMSetCheck(hWnd, IDC_VERIFY_LISTVIEW, config.isDisplayVerificationResultOnListView());
            DWORD dtVerificationResult = config.getDisplayTimeVerificationResult();
            char buffer[100];
            itoa(dtVerificationResult, &buffer[0], 10);
            EMLimitText(hWnd, IDC_VERIFY_LISTVIEW_MS, 10);
            WMSetText(hWnd, IDC_VERIFY_LISTVIEW_MS, &buffer[0]);
            InitColor(hWnd, config);
            BMSetCheck(hWnd, IDC_VERIFY_LISTVIEW_ERASEBACK, config.isEraseBackgroundOfListView());

			bool enableListView = config.isDisplayVerificationResultOnListView();
            EnableDlgItem(hWnd, IDC_VERIFY_LISTVIEW_MS,        enableListView);
            EnableDlgItem(hWnd, IDC_VERIFY_LISTVIEW_GOODCOL,   enableListView);
            EnableDlgItem(hWnd, IDC_VERIFY_LISTVIEW_BADCOL,    enableListView);
            EnableDlgItem(hWnd, IDC_VERIFY_LISTVIEW_ERASEBACK, enableListView);

            return TRUE;
        }
        break;

    case WM_MEASUREITEM:
        OnMeasureItemColorCombo(lParam);
        return TRUE;
    case WM_DRAWITEM:
        OnDrawItemColorCombo(lParam);
        return TRUE;
    default:
        break;
    }

    return FALSE;
}


/*------------------------------------------------
@uFvR{{bNX̏
--------------------------------------------------*/
void InitColor(HWND hDlg, Config& config)
{
    COLORREF col;
    int i, j;
    WORD id;

    //WindowsftHg16F
    int rgb[16][3] = {
        {255,255,255},{0,255,255},{255,0,255},{0,0,255},
        {255,255,0},  {0,255,0},  {255,0,0},  {128,128,128},
        {192,192,192},{0,128,128},{128,0,128},{0,0,128},
        {128,128,0},  {0,128,0},  {128,0,0},  {0,0,0}
    };

    for(i = 0; i < 2; i++)
    {
        if(i == 0) {
            id = IDC_VERIFY_LISTVIEW_GOODCOL;
        } else {
            id = IDC_VERIFY_LISTVIEW_BADCOL;
        }

        for(j = 0; j < 16; j++) {//{16F
            CBAddString(hDlg, id, RGB(rgb[j][0], rgb[j][1], rgb[j][2]));
        }

        //{^...F
        CBAddString(hDlg, id, RGB(255,255,255));

        //R{{bNX̐FI
        if (i == 0) {
            col = config.getDisplayColorVerificationCorrect();
        } else {
            col = config.getDisplayColorVerificationInCorrect();
        }

        for(j = 0; j < 17; j++)
        {
            if(col == (COLORREF)CBGetItemData(hDlg, id, j)) {
                break;
            }
        }
        if(j == 17) {//16FɂȂƂ
            CBAddString(hDlg, id, col);
        }

        CBSetCurSel(hDlg, id, j);
        SetSelNumber(id, j);
    }
}

/*------------------------------------------------
@uFvR{{bNX̍̐ݒ
--------------------------------------------------*/
void OnMeasureItemColorCombo(LPARAM lParam)
{
    LPMEASUREITEMSTRUCT pmis;

    pmis = (LPMEASUREITEMSTRUCT)lParam;
    pmis->itemHeight = 7 * HIWORD(GetDialogBaseUnits()) / 8;
}

/*------------------------------------------------
@uFvR{{bNX̃I[i[h[
--------------------------------------------------*/
void OnDrawItemColorCombo(LPARAM lParam)
{
    LPDRAWITEMSTRUCT pdis;
    HBRUSH hbr;
    COLORREF col;
    TEXTMETRIC tm;
    int y;

    pdis = (LPDRAWITEMSTRUCT)lParam;

    if(IsWindowEnabled(pdis->hwndItem)) {
        col = pdis->itemData;
    } else {
        col = GetSysColor(COLOR_3DFACE);
    }

    switch(pdis->itemAction)
    {
        case ODA_DRAWENTIRE:
        case ODA_SELECT:
        {
            hbr = CreateSolidBrush(col);
            FillRect(pdis->hDC, &pdis->rcItem, hbr);
            DeleteObject(hbr);

            // print color names
            if(pdis->itemID == 16) {
                char s[80];

                strcpy(s, "Others...");
                SetBkMode(pdis->hDC, TRANSPARENT);
                GetTextMetrics(pdis->hDC, &tm);
                y = (pdis->rcItem.bottom - pdis->rcItem.top - tm.tmHeight)/2;
                TextOut(pdis->hDC, pdis->rcItem.left + 4, pdis->rcItem.top + y,
                    s, strlen(s));
            }
            if(!(pdis->itemState & ODS_FOCUS)) {
                break;
            }
        }
        case ODA_FOCUS:
        {
            if(pdis->itemState & ODS_FOCUS)
                hbr = CreateSolidBrush(0);
            else
                hbr = CreateSolidBrush(col);
            FrameRect(pdis->hDC, &pdis->rcItem, hbr);
            DeleteObject(hbr);
            break;
        }
    }
}

/*------------------------------------------------
@F̑I u...v{^
--------------------------------------------------*/
void OnChooseColor(HWND hDlg, WORD id)
{
    CHOOSECOLOR cc;
    COLORREF col, colarray[16];
    int i;

    //ŏɑI΂ĂF
    col = CBGetItemData(hDlg, id, CBGetCurSel(hDlg, id));

    for(i = 0; i < 16; i++) {
        colarray[i] = RGB(255,255,255);
    }

    memset(&cc, 0, sizeof(CHOOSECOLOR));
    cc.lStructSize = sizeof(CHOOSECOLOR);
    cc.hwndOwner = hDlg;
    //cc.hInstance = g_hInst;
    cc.rgbResult = col;
    cc.lpCustColors = colarray;
    cc.Flags = CC_FULLOPEN | CC_RGBINIT;

    if(!ChooseColor(&cc)) {
        CBSetCurSel(hDlg, id, GetSelNumber(id));
        return;
    }

    for(i = 0; i < 16; i++) {
        if(cc.rgbResult == (COLORREF)CBGetItemData(hDlg, id, i)) {
            break;
        }
    }
    if(i == 16) { //{16Fł͂ȂƂ
        if(CBGetCount(hDlg, id) == 17) {
            CBAddString(hDlg, id, cc.rgbResult);
        } else {
            CBSetItemData(hDlg, id, 17, cc.rgbResult);
        }
        i = 17;
    }
    CBSetCurSel(hDlg, id, i);
    SetSelNumber(id, i);

    PostMessage(hDlg, WM_NEXTDLGCTL, 1, FALSE);
}

////////////////////////////////////////////////////////////////////////
//
