/**
 * @file SetupDialog.h
 * @brief PGPB2̐ݒ_CAO
 * @author  Copyright (C) 2002 YUGA <yuga@ops.dti.ne.jp>
 * $Date: $
 * $Revision: $
 *
 */


/////////////////////////////////////////////////////////////////////////////////
//
#include "main.h"
#include <commctrl.h>


/////////////////////////////////////////////////////////////////////////////////
//
// Macros
#define EnableDlgItem(hDlg,id,b)        EnableWindow(GetDlgItem((hDlg),(id)),(b)? TRUE:FALSE)
#define ShowDlgItem(hDlg,id,b)          ShowWindow(GetDlgItem((hDlg),(id)),(b)?SW_SHOW:SW_HIDE)

#define CBAddString(hDlg,id,lParam)     SendDlgItemMessage((hDlg),(id),CB_ADDSTRING,0,(lParam))
#define CBDeleteString(hDlg,id, i)      SendDlgItemMessage((hDlg),(id),CB_DELETESTRING,(i),0)
#define CBFindString(hDlg,id,s)         SendDlgItemMessage((hDlg),(id),CB_FINDSTRING,0,(LPARAM)(s))
#define CBFindStringExact(hDlg,id,s)    SendDlgItemMessage((hDlg),(id),CB_FINDSTRINGEXACT,0,(LPARAM)(s))
#define CBGetCount(hDlg,id)             SendDlgItemMessage((hDlg),(id),CB_GETCOUNT,0,0)
#define CBGetCurSel(hDlg,id)            SendDlgItemMessage((hDlg),(id),CB_GETCURSEL,0,0)
#define CBGetItemData(hDlg,id,i)        SendDlgItemMessage((hDlg),(id),CB_GETITEMDATA,(i),0)
#define CBGetLBText(hDlg,id,i,s)        SendDlgItemMessage((hDlg),(id),CB_GETLBTEXT,(i),(LPARAM)(s))
#define CBInsertString(hDlg,id,i,s)     SendDlgItemMessage((hDlg),(id),CB_INSERTSTRING,(i),(LPARAM)(s))
#define CBResetContent(hDlg,id)         SendDlgItemMessage((hDlg),(id),CB_RESETCONTENT,0,0)
#define CBSetCurSel(hDlg,id,i)          SendDlgItemMessage((hDlg),(id),CB_SETCURSEL,(i),0)
#define CBSetItemData(hDlg,id,i,lParam) SendDlgItemMessage((hDlg),(id),CB_SETITEMDATA,(i),(lParam))

#define BMGetCheck(hDlg,id)             SendDlgItemMessage((hDlg),(id),BM_GETCHECK,0,0) == BST_CHECKED ? true:false
#define BMSetCheck(hDlg,id,check)       SendDlgItemMessage((hDlg),(id),BM_SETCHECK,(check)? TRUE:FALSE,0);
#define DTMGetSystemTime(hDlg,id,pTime) SendDlgItemMessage((hDlg),(id),DTM_GETSYSTEMTIME,GDT_VALID,reinterpret_cast<LPARAM>(pTime));
#define DTMSetSystemTime(hDlg,id,pTime) SendDlgItemMessage((hDlg),(id),DTM_SETSYSTEMTIME,GDT_VALID,reinterpret_cast<LPARAM>(pTime));
#define DTMSetFormat(hDlg,id,pFormat)   SendDlgItemMessage((hDlg),(id),DTM_SETFORMAT,0,reinterpret_cast<LPARAM>(pFormat));
#define WMGetText(hDlg,id,limit,pText)  SendDlgItemMessage((hDlg),(id),WM_GETTEXT,(limit),reinterpret_cast<LPARAM>(pText));
#define EMLimitText(hDlg,id,limit)      SendDlgItemMessage((hDlg),(id),EM_LIMITTEXT,(limit),0);
#define WMSetText(hDlg,id,pText)        SendDlgItemMessage((hDlg),(id),WM_SETTEXT,0,reinterpret_cast<LPARAM>(pText));


/////////////////////////////////////////////////////////////////////////////////
//
static void InitColor(HWND hDlg, Config& config);
static void OnMeasureItemColorCombo(LPARAM lParam);
static void OnDrawItemColorCombo(LPARAM lParam);
static void OnChooseColor(HWND hDlg, WORD id);
static void OnCheckColor2(HWND hDlg);


/////////////////////////////////////////////////////////////////////////////////
//
